#!/usr/bin/perl
# Copyright
# (c) 2000 Elisabeth Dregger-Cappel
# (c) 2002 Hans-Georg Eer

# Ggf. zu ndernde Variable:
# 1. $netif: PPP-Interface
$netif = "ppp0";
# 2. $usenetctl
#     = 2: PPP-Interface wird mit cinternet (SuSE 8.1) gestartet
#     = 1: PPP-Interface ist mit netcfg eingerichtet
#     = 0: PPP-Interface ist ber wvdialconf (bzw. yast) eingerichtet
$usenetctl = 2;

print "Content-Type: text/html\r\nCache-Control: no-cache\r\n\r\n";
$htdoc = $ENV{'PATH_TRANSLATED'};
$script = $ENV{'SCRIPT_NAME'};

if ($htdoc =~ m|^/\S+| && open(IN,$htdoc))
{ $inbodytag = 0;
  while (<IN>)
  { print $_;
    last if (/<body.*>/i || />/ && $inbodytag);
    $inbodytag = 1 if (/<body/i);
  }
  $dodoc = 1;
  $script .= $ENV{'PATH_INFO'};
}
else
{ print <<"EOF";
<html>
<head>
<title>Zugang zum Internet...</title>
</head>
<body>
EOF
  $dodoc = 0;
}

if ($usenetctl eq 0)
{ system("/usr/sbin/usernetctl $netif report");
  $isup = $?;
}
elsif ($usenetctl eq 1)
{ $isup = 0;
  open(IF,"/sbin/ifconfig $netif|");
  while (<IF>)
  { $isup = 1 if (/\s+UP\s+/);
    $ipaddr = $1 if (/\s+inet addr:(\S+)\s/);
  }
  close(IF);
}
else
{ $isup = 0;
  # SuSE 8.1
  open(IF,"/usr/sbin/cinternet --status|");
  while (<IF>)  { $isup = 1 if (/\s+ CONNECTED\s+/); }
  close(IF);
}

if ($isup)
{ print "Die Verbindung zum Internet steht!<br>";
  print "(IP-Adresse $ipaddr)<br>" if (defined($ipaddr));
}
else
{ print "Die Verbindung zum Internet steht <STRONG>nicht</STRONG>!<br>";
}

$func = $ENV{'QUERY_STRING'};
$func =~ s/^f=//;
$| = 1;

if ($func eq "up")
{ if ($usenetctl eq 0)
  { system("/usr/sbin/usernetctl $netif up");
  }
  elsif ($usenetctl eq 1)
  { $SIG{SIGCHLD} = "IGNORE";
    $pid = fork();
    if ($pid == 0)
    { $SIG{SIGINT} = "IGNORE";
      $SIG{SIGHUP} = "IGNORE";
      close(STDOUT);
      close(STDERR);
      open(STDOUT,">/tmp/wvdial-cgi.out");
      open(STDERR,">/tmp/wvdial-cgi.err");
      exec("/usr/bin/wvdial");
    }
  }
  else
  { # SuSE 8.1
    system("/usr/sbin/cinternet --start");
  }
  print "<STRONG>Verbindung wird jetzt aufgebaut.</STRONG><br>";
}
elsif ($func eq "down")
{ if ($usenetctl eq 0)
  { system("/usr/sbin/usernetctl $netif down");
  }
  elsif ($usenetctl eq 1)
  { system("/usr/bin/killall -TERM wvdial");
  }
  else
  { # SuSE 8.1
    system("/usr/sbin/cinternet --stop");
  }
  print "<STRONG>Verbindung wird jetzt abgebaut.</STRONG><br>";
}
elsif ($isup)
{ print "<A HREF=\"$script?f=down\">Verbindung abbauen</A><br>";
}
else
{ print "<A HREF=\"$script?f=up\">Verbindung aufbauen</A><br>";
}

print "<p> Zurck: <a href=\"";
print $script;
print "\">Hier klicken</a> <p>";

if ($dodoc)
{ while (<IN>)
  { print $_;
  }
  close(IN);
}
else
{ print <<"EOF";
</body>
</html>
EOF
}
